*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\BACKUP\\BACKUP.PRG
*+
*+    Copyright(C) 1983-2021 by Auge & Ohr
*+
*+    Functions: Procedure MAIN()
*+               Static Function CloseThread()
*+               Static Procedure DoInit()
*+               Static Procedure GetSourceFolder()
*+               Static Procedure Open_Combo()
*+               Static Procedure FillCombo()
*+               Static Procedure DoComboImage()
*+               Static Function AddDiskText()
*+               Static Procedure DoNow()
*+               Static Function SHThread()
*+               Procedure Clean_Label()
*+               Function Recudirs()
*+               Static Function CheckDupeOK()
*+               Procedure DoEject()
*+               Static Function No_Backshlash()
*+               Function USB_Detect()
*+               Static Function Wait4Action()
*+               Static Function GetMaskDrive()
*+
*+    Reformatted by Click! 2.05.38 on Aug-26-2021 at  2:13 am
*+
*+--------------------------------------------------------------------

#include "HMG.CH"
#include "COMMON.CH"
#include "DLL.CH"
#include "HBDYN.CH"
#include "DIRECTRY.CH"
#include "FILEIO.CH"
#include "hbthread.ch"

#include "BACKUP.CH"

#define LBS_USETABSTOPS       128  //    0x80
#define LB_SETTABSTOPS        0x0192

#define EM_SETTABSTOPS        0x00CB

#define WM_DEVICECHANGE             0x0219
#define DBT_DEVICEARRIVAL           0x8000
#define DBT_DEVICEQUERYREMOVE       0x8001
#define DBT_DEVICEREMOVECOMPLETE    0x8004

#xtranslate DllCall              => HMG_CallDLL

REQUEST HB_LANG_ES
REQUEST HB_LANG_EN
REQUEST HB_LANG_FR
REQUEST HB_LANG_PT
REQUEST HB_LANG_DEWIN
REQUEST HB_LANG_RUWIN
REQUEST HB_LANG_IT
REQUEST HB_LANG_PLWIN
REQUEST HB_LANG_EU
REQUEST HB_LANG_HR852
REQUEST HB_LANG_SLWIN
REQUEST HB_LANG_CSWIN

REQUEST HB_CODEPAGE_ESWIN
REQUEST HB_CODEPAGE_BGWIN
REQUEST HB_CODEPAGE_DEWIN
REQUEST HB_CODEPAGE_ELWIN
REQUEST HB_CODEPAGE_HUWIN
REQUEST HB_CODEPAGE_PLWIN
REQUEST HB_CODEPAGE_PT850
REQUEST HB_CODEPAGE_RU1251
REQUEST HB_CODEPAGE_SRWIN
REQUEST HB_CODEPAGE_SLWIN

STATIC caItems     := {}                                              // for ComboBox
STATIC acImage     := {}
STATIC aDrives     := {}
STATIC aStartDrive := {}
STATIC aFilesCopy  := {}
STATIC lWorking    := .F.
STATIC nFilesSum   := 0
STATIC s_mtxUSB    := 0
STATIC s_mtxReturn := 0
STATIC lOnlyNew    := .F.
STATIC cFullSource := ""
STATIC cVersion    := "v0.16"

MEMVAR _HMG_SYSDATA
MEMVAR aWatchThread
MEMVAR aThread

// *********************************************************************
//  25.08.2021 v0.16 no CheckDupeOK()
//  17.08.2021 v0.15 CheckDupeOK()
//  16.08.2021 v0.14 Codepage.PRG
//  13.08.2021 v0.13 RunAsThread()
//  02.08.2021 v0.12 USB_Detect()
//  22.07.2021 v0.11 get free HB_DISKSPACE() of Target before copy
//  15.07.2021 v0.10 OUTLOOK.PST / RegClass
//  05.07.2021 v0.09 without Everything (
//  05.07.2021 v0.08 working undern 64 Bit UNICODE HB_FUNC -> HMG_
//  05.07.2021 v0.07 reduce Parameter
//  04.07.2021 v0.06 MAX_PATH Error under x64
//  03.07.2021 v0.05 split into TOOLS.PRG, USBEJECT.PRG
//  03.07.2021 v0.04 working Backup ShellFileOperation ANSI Version ?!
// *********************************************************************

*+--------------------------------------------------------------------
*+
*+    Procedure MAIN()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MAIN

LOCAL nCountry := HB_bitAND( GETKEYBOARDLAYOUT(), 0xFFFF )
LOCAL nIndex
LOCAL lVisible := .T.

PUBLIC aWatchThread := { nil, nil }
PUBLIC aThread      := { NIL }

   IF Search4Outlook()
      lVisible := .T.
   ELSE
      lVisible := .F.
   ENDIF

   SET EPOCH TO YEAR( DATE() ) - 50
   SET CENTURY ON
   SET DECIMAL TO 0

   Search4Codepage()

   s_mtxUSB := hb_mutexCreate()                                       //Mutex for Wait4Action thread
   s_mtxReturn := hb_mutexCreate()                                    //Return mutex for event USB_Detect main thread

   // Image Combobox
   AADD( acImage, "MYUNKNOWN16" )
   AADD( acImage, "MYFIXDRIVE16" )
   AADD( acImage, "MYUSBSTICK16" )
   AADD( acImage, "MYSYSDRIVE16" )
   AADD( acImage, "MYFIXDRIVE16" )
   AADD( acImage, "MYNETDRIVE16" )
   AADD( acImage, "MYCDROM16" )
   AADD( acImage, "MYRAMDISK16" )

   FillCombo()

   DEFINE WINDOW BackDlg ;
         AT 513, 432 ;
         WIDTH 730 ;
         HEIGHT 384 ;
         TITLE "Backup " + cVersion ;
         ICON "A1MAIN" ;
         MAIN ;
         NOMAXIMIZE ;
         NOMINIMIZE ;
         NOSIZE ;
         ON INIT DoInit() ;
         ON RELEASE Nil ;
         BACKCOLOR { 8, 8, 8 }

      DEFINE TEXTBOX Text_From
         ROW 20
         COL 20
         WIDTH 680
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "Source Directory"
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         RIGHTALIGN .F.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         CASECONVERT NONE
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR NIL
         INPUTMASK Nil
         FORMAT Nil
         VALUE ""
      END TEXTBOX

      DEFINE BUTTON Button_Source
         ROW 54
         COL 20
         WIDTH 120
         HEIGHT 34
         ACTION GetSourceFolder()
         CAPTION "&Source"
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "get Folder Source Directory"
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         MULTILINE .F.
         PICTURE Nil
         PICTALIGNMENT TOP
      END BUTTON

      DEFINE CHECKBOX Check_NewFile
         ROW 54
         COL 150
         WIDTH 120
         HEIGHT 34
         CAPTION "&New File"
         VALUE .T.
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "only get Files with Attribut 'A' (else all Files)"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE CHECKBOX Check_Attrib
         ROW 54
         COL 280
         WIDTH 160
         HEIGHT 34
         CAPTION "&clear Attribut"
         VALUE .T.
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "reset Attribut 'A'"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE CHECKBOX Check_PST
         ROW 54
         COL 450
         WIDTH 250
         HEIGHT 34
         CAPTION "Office &PST Files"
         VALUE lVisible
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "include Outlook.PST File"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         TABSTOP .T.
         VISIBLE lVisible
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE CHECKBOX Check_SubDir
         ROW 210
         COL 450
         WIDTH 250
         HEIGHT 34
         CAPTION "&include Sub-Directory"
         VALUE .T.
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "include Sub-Directory"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE COMBOBOX Combo_Target
         ROW 116
         COL 20
         WIDTH 680
         HEIGHT 200
         ITEMS caItems
         IMAGE acImage
         VALUE 0
         FONTNAME "Lucida Console"
         FONTSIZE 16
         FONTBOLD .F.
         TOOLTIP "Backup Drive"
         TABSTOP .T.
         VISIBLE .T.
         SORT .F.
         ONENTER Nil
         ONDISPLAYCHANGE Nil
         DISPLAYEDIT .F.
         DROPPEDWIDTH Nil
         ONDROPDOWN nil
         ONCLOSEUP Nil
         BACKCOLOR { 192, 192, 192 }
      END COMBOBOX

      DEFINE BUTTON Button_Target
         ROW 156
         COL 20
         WIDTH 120
         HEIGHT 34
         ACTION Open_Combo()
         CAPTION "&Target"
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "get Backup Drive"
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         MULTILINE .F.
         PICTURE Nil
         PICTALIGNMENT TOP
      END BUTTON

      DEFINE CHECKBOX Check_Confim
         ROW 156
         COL 150
         WIDTH 120
         HEIGHT 34
         CAPTION "&Confim"
         VALUE .F.
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "confirm all Yes/No with default (Yes)"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE CHECKBOX Check_Eject
         ROW 156
         COL 280
         WIDTH 160
         HEIGHT 34
         CAPTION "Eject-&USB"
         VALUE .T.
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "eject Backup Drive when finish"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE CHECKBOX Check_Rename
         ROW 155
         COL 450
         WIDTH 250
         HEIGHT 34
         CAPTION "&RenameOnCollision"
         VALUE .F.
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "Rename ON / Override OFF"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE BUTTON Button_Go
         ROW 210
         COL 20
         WIDTH 120
         HEIGHT 120
         ACTION DoNow()
         CAPTION "&Go"
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "Start Backup"
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         MULTILINE .F.
         PICTURE Nil
         PICTALIGNMENT TOP
      END BUTTON

      DEFINE BUTTON Button_Eject
         ROW 210
         COL 150
         WIDTH 120
         HEIGHT 120
         ACTION DoEject()
         CAPTION "&Eject"
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "eject Backup Drive now"
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         MULTILINE .F.
         PICTURE Nil
         PICTALIGNMENT TOP
      END BUTTON

      DEFINE LABEL Label_1
         ROW 210
         COL 280
         WIDTH 160
         HEIGHT 24
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 10
         TOOLTIP ""
         VISIBLE .T.
         TRANSPARENT .F.
         BACKCOLOR { 8, 8, 8 }
         FONTCOLOR { 0, 255, 255 }
      END LABEL

      DEFINE LABEL Label_2
         ROW 235
         COL 280
         WIDTH 160
         HEIGHT 24
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 10
         TOOLTIP ""
         VISIBLE .T.
         TRANSPARENT .F.
         AUTOSIZE .F.
         BACKCOLOR { 8, 8, 8 }
         FONTCOLOR { 0, 255, 255 }
      END LABEL

      DEFINE LABEL Label_3
         ROW 260
         COL 280
         WIDTH 160
         HEIGHT 24
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 10
         TOOLTIP ""
         VISIBLE .T.
         TRANSPARENT .F.
         BACKCOLOR { 8, 8, 8 }
         FONTCOLOR { 0, 255, 255 }
      END LABEL

      DEFINE LABEL Label_4
         ROW 285
         COL 280
         WIDTH 440
         HEIGHT 24
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 10
         TOOLTIP ""
         VISIBLE .T.
         TRANSPARENT .F.
         BACKCOLOR { 8, 8, 8 }
         FONTCOLOR { 0, 255, 255 }
      END LABEL

      DEFINE LABEL Label_5
         ROW 310
         COL 280
         WIDTH 440
         HEIGHT 24
         VALUE ""
         FONTNAME "Arial"
         FONTSIZE 10
         TOOLTIP ""
         VISIBLE .T.
         TRANSPARENT .F.
         BACKCOLOR { 8, 8, 8 }
         FONTCOLOR { 0, 255, 255 }
      END LABEL

      DEFINE CHECKBOX Check_Hidden
         ROW 246
         COL 450
         WIDTH 250
         HEIGHT 34
         CAPTION "&Hidden Directory"
         VALUE .T.
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP "include Hidden Directory"
         BACKCOLOR { 192, 192, 192 }
         FONTCOLOR { 0, 255, 255 }
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
      END CHECKBOX

      DEFINE FRAME Frame_From
         ROW 0
         COL 10
         WIDTH 698
         HEIGHT 94
         FONTNAME "Arial"
         FONTSIZE 10
         CAPTION "From"
         BACKCOLOR NIL
         FONTCOLOR { 0, 255, 255 }
         OPAQUE .T.
      END FRAME

      DEFINE FRAME Frame_To
         ROW 96
         COL 10
         WIDTH 698
         HEIGHT 100
         FONTNAME "Arial"
         FONTSIZE 10
         CAPTION "To"
         BACKCOLOR NIL
         FONTCOLOR { 0, 255, 255 }
         OPAQUE .F.
      END FRAME

   END WINDOW

   DoComboImage( .T. )

   aThread[ 1 ] := hb_threadStart( HB_BITOR( HB_THREAD_INHERIT_PUBLIC, HB_THREAD_MEMVARS_COPY ), @Wait4Action() )
   CREATE EVENT PROCNAME USB_Detect() HWND BackDlg.HANDLE STOREINDEX nIndex

   CENTER WINDOW BackDlg
   Activate Window BackDlg

   CloseThread()
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function CloseThread()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CloseThread()

LOCAL i
   FOR i := 1 TO LEN( aThread )
      IF aThread[ i ] <> NIL
         hb_threadDetach( aThread[ i ] )                              // close thread handle
         hb_threadQuitRequest( aThread[ i ] )                         // terminate thread
         aThread[ i ] := NIL
      ENDIF
   NEXT
RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoInit()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoInit()

LOCAL aTabs := { 100, 200, 300 }
LOCAL cHMG  := GETENV( "HMGPATH" )
   IF EMPTY( cHMG )
      cHMG := "c:\hmg.3.4.4\"
   ENDIF
   BackDlg.Text_From.Value := No_Backshlash( cHMG )

   IF EMPTY( GetSetPST() )
      BackDlg.Check_PST.Enabled := .F.
      BackDlg.Check_PST.Value := .F.
   ENDIF

   SnapToCtrl( "BackDlg", "Button_Go" )
   Domethod( "BackDlg", "Button_Go", "SetFocus" )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure GetSourceFolder()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE GetSourceFolder()

LOCAL cRet             := ""
LOCAL cTitle           := "Source Folder"
LOCAL cInitPath        := ""
LOCAL lNewFolderButton := .F.

   cInitPath := No_Backshlash( BackDlg.Text_From.Value )
   cRet := GetFolder( cTitle, TRIM( cInitPath ),, lNewFolderButton )
   IF !EMPTY( cRet )
      BackDlg.Text_From.Value := No_Backshlash( cRet )
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Open_Combo()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Open_Combo()

   SnapToCtrl( "BackDlg", "Combo_Target" )
   Domethod( "BackDlg", "Combo_Target", "SetFocus" )

   Keybd_Event( VK_F4, .F. )                                          // KeyDown
   Keybd_Event( VK_F4, .T. )                                          // KeyUp
   DO EVENTS                                                          // need for Keybd_Event()

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure FillCombo()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+                                   1 - static function wait4action()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE FillCombo( lDelete )

LOCAL cDrive, cVolume, nDrive, nType, ico, i, nFreeSpace, nTotalDisk, cAddText

   aStartDrive := {}
   caItems := {}
   aDrives := GetDrives()

   FOR i := 1 TO LEN( aDrives )
      nType := aDrives[ i ] [ DRV_TYPE ]
      cDrive := aDrives[ i ] [ DRV_NAME ]
      cVolume := PADR( aDrives[ i ] [ DRV_VOLU ], 11 )

      nFreeSpace := ROUND( hb_DiskSpace( aDrives[ i ] [ DRV_NAME ] + ":" ), 0 )
      nTotalDisk := ROUND( hb_DiskSpace( aDrives[ i ] [ DRV_NAME ] + ":", HB_DISK_TOTAL ), 0 )
      cAddText := AddDiskText( nFreeSpace, nTotalDisk )

      DO CASE
         CASE nType = DRIVE_UNKNOWN
            AADD( caItems, { IM_UNKNOWN, cDrive + " " + cVolume + cAddText } )
         CASE nType = DRIVE_NO_ROOT_DIR
            AADD( caItems, { IM_FIXDRIVE1, cDrive + " " + cVolume + cAddText } )
         CASE nType = DRIVE_REMOVABLE
            AADD( caItems, { IM_USBSTICK, cDrive + " " + cVolume + cAddText } )
            AADD( aStartDrive, cDrive )
         CASE nType = DRIVE_FIXED
            IF cDrive = "C"
               AADD( caItems, { IM_SYSDRIVE, cDrive + " " + cVolume + cAddText } )
            ELSE
               AADD( caItems, { IM_FIXDRIVE, cDrive + " " + cVolume + cAddText } )
            ENDIF
         CASE nType = DRIVE_REMOTE
            AADD( caItems, { IM_NETDRIVE, cDrive + " " + cVolume + cAddText } )
         CASE nType = DRIVE_CDROM
            AADD( caItems, { IM_CDROM, cDrive + " " + cVolume + cAddText } )
         CASE nType = DRIVE_RAMDISK
            AADD( caItems, { IM_RAMDISK, cDrive + " " + cVolume + cAddText } )
         OTHERWISE
            AADD( caItems, { IM_UNKNOWN, cDrive + " " + cVolume + cAddText } )
      ENDCASE
   NEXT

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoComboImage()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+                                   1 - static function wait4action()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoComboImage( lRefresh )

LOCAL i, ii, iiMax, xVal, nDrive := 1

   DEFAULT lRefresh TO .F.

   IF lRefresh = .T.
      Domethod( "BackDlg", "Combo_Target", "hide" )
      Domethod( "BackDlg", "Combo_Target", "DeleteAllItems" )

      iiMax := LEN( caItems )
      FOR ii := 1 TO iiMax
         xVal := caItems[ ii ]
         BackDlg.Combo_Target.AddItem( xVal )
      NEXT
   ENDIF

   IF EMPTY( aStartDrive )
      //  MsgInfo("no removeable Drive !")
   ELSE
      nDrive := ASCAN( aDrives, { | e | e[ 2 ] = aStartDrive[ 1 ] } )
   ENDIF
   SetProperty( "BackDlg", "Combo_Target", "VALUE", nDrive )

   Domethod( "BackDlg", "Combo_Target", "show" )

   IF EMPTY( aStartDrive )
      BackDlg.Label_1.BACKCOLOR := { 255, 0, 0 }
      BackDlg.Label_1.FONTCOLOR := { 255, 255, 255 }
      BackDlg.Label_1.Value := "   no removeable Drive !"
   ELSE
      BackDlg.Label_1.BACKCOLOR := { 8, 8, 8 }
      BackDlg.Label_1.FONTCOLOR := { 0, 255, 255 }
      BackDlg.Label_1.Value := ""
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function AddDiskText()
*+
*+    Called from ( backup.prg )   1 - static procedure fillcombo()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION AddDiskText( nFreeSpace, nFilesSum )

LOCAL cText := " "

   cText += STR( nFreeSpace / 1024 / 1000 )
   cText += " Mb free of "
   cText += STR( nFilesSum / 1024 / 1000 ) + " Mb"

RETURN cText

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoNow()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoNow()

LOCAL cPath
LOCAL a_DIR
LOCAL nButton      := 0
LOCAL nFreeSpace   := 0
LOCAL nStart, nStart1, nStart2, nStart3
LOCAL lWantPST     := BackDlg.Check_PST.Value
LOCAL lConfirm     := BackDlg.Check_Confim.Value
LOCAL nDrive       := GetProperty( "BackDlg", "Combo_Target", "VALUE" )
LOCAL cDriveTarget := aDrives[ nDrive ] [ DRV_NAME ]

   nFilesSum := 0
   aFilesCopy := {}
   cFullSource := No_Backshlash( BackDlg.Text_From.Value )

   BackDlg.Label_1.BACKCOLOR := { 8, 8, 8 }
   BackDlg.Label_1.FONTCOLOR := { 0, 255, 255 }

   Clean_Label()
   BackDlg.Label_1.Value := "Start " + TIME()

   nStart := SECONDS()

   IF lWantPST = .T.
      IF lConfirm = .T.
         IF MsgYesNo( "search for Outlook.PST ?", "Outlook.PST" )
            nButton := "XBPMB_RET_OK"
         ELSE
            nButton := "XBPMB_RET_NO"
         ENDIF
      ELSE
         nButton := "XBPMB_RET_OK"
      ENDIF

      IF nButton = "XBPMB_RET_OK"
         lWorking := .T.
         cPath := GetSetPST()
         IF !EMPTY( cPath )
            nStart2 := SECONDS()
            a_DIR := DIRECTORY( cPath )
            AADD( aFilesCopy, { cPath, "", a_DIR[ 1, F_ATTR ], a_DIR[ 1, F_SIZE ] } )
            nFilesSum += a_DIR[ 1, F_SIZE ]
            BackDlg.Label_2.Value := "Stop " + " " + LTRIM( STR( SECONDS() - nStart2 ) ) + " Sec."
         ENDIF
         lWorking := .F.
      ENDIF
   ENDIF

   lWorking := .T.
   nStart3 := SECONDS()

   // now search recursiv in Directory
   RECUDIRS( cFullSource + "\", "*.*" )
   lWorking := .F.
   BackDlg.Label_3.Value := "Files add " + LTRIM( STR( SECONDS() - nStart3 ) ) + " Sec."
   BackDlg.Label_4.Value := LTRIM( STR( LEN( aFilesCopy ) ) ) + " Files " + STR( nFilesSum / 1000000 ) + " MB"

   nFreeSpace := hb_DiskSpace( cDriveTarget + ":" )
   IF nFreeSpace < nFilesSum
      MsgInfo( "Insufficient disk space for copying!" + CRLF + ;
               LTRIM( STR( nFreeSpace / 1024 / 1000 / 1000 ) ) + " Mb" + CRLF + ;
               LTRIM( STR( nFilesSum / 1024 / 1000 / 1000 ) ) + " Mb" )
      Clean_Label()
      RETURN
   ENDIF

   nStart2 := SECONDS()
   lWorking := .T.
   lOnlyNew := BackDlg.Check_NewFile.Value
   IF lOnlyNew = .T.
      IF ASCAN( aFilesCopy, { | x | "A" $ x[ ID_ATTR ] } ) > 0
         SHThread( "COPY" )
      ELSE
         MSGInfo( "no new Files" )
      ENDIF
   ELSE
      SHThread( "COPY" )
   ENDIF
   lWorking := .F.
   BackDlg.Label_2.Value := "Stop " + " " + LTRIM( STR( SECONDS() - nStart2 ) ) + " Sec."
   BackDlg.Label_5.Value := "Stop " + " " + LTRIM( STR( SECONDS() - nStart ) ) + " Sec."

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function SHThread()
*+
*+    Called from ( backup.prg )   2 - static procedure donow()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION SHThread( cAktion )

LOCAL lRet         := .F.
LOCAL aData        := ACLONE( aFilesCopy )
LOCAL nLen         := LEN( aData )
LOCAL nButton      := 0
LOCAL cSpace       := ""
LOCAL aToDo        := {}                                              // Array reset "A"
LOCAL acFiles      := {}
LOCAL acTarget     := {}
LOCAL lPaperbin    := .F.
LOCAL lAdjustTime  := .F.
LOCAL nFreeSpace   := 0
LOCAL i
LOCAL j, jMax
LOCAL cSourceDir
LOCAL cTargetDir
LOCAL c_Path
LOCAL c_File
LOCAL n_Size
LOCAL c_Attr
LOCAL nAttr
LOCAL cTry
LOCAL cDriveTarget
LOCAL nDrive       := GetProperty( "BackDlg", "Combo_Target", "VALUE" )
LOCAL nCountry     := HB_bitAND( GETKEYBOARDLAYOUT(), 0xFFFF )

   cDriveTarget := aDrives[ nDrive ] [ DRV_NAME ]

   FOR i = 1 TO nLen
      c_Path := aData[ i ] [ ID_PATH ]
      c_File := aData[ i ] [ ID_NAME ]
      c_Attr := aData[ i ] [ ID_ATTR ]
      n_Size := aData[ i ] [ ID_SIZE ]

      IF LEN( c_Path + c_File ) > 256
         System.Clipboard := c_Path + c_File
         MsgInfo( "Filename > 256 (Filename was copy to Clipboard)", "Error MAX_PATH" )
         LOOP
      ENDIF

      IF lOnlyNew = .T.
         IF "A" $ c_Attr
            AADD( aToDo, { c_Path + c_File, n_Size, c_Attr } )
         ELSE
            LOOP
         ENDIF
      ELSE
         AADD( aToDo, { c_Path + c_File, n_Size, c_Attr } )
      ENDIF

      // Each file name is terminated by a single NULL character
      cSourceDir := TRIM( c_Path + c_File )                           // +CHR(0)
      cTargetDir := TRIM( ChangeDriveLetter( cSourceDir, cDriveTarget ) )                                                                   // +CHR(0)

      // Source
      AADD( acFiles, cSourceDir )

      // Target
      IF cAktion = "DELETE"
         AADD( acTarget, "" )
      ELSE
         AADD( acTarget, cTargetDir )
      ENDIF

      IF lOnlyNew = .T.
         IF FILE( cTargetDir )
            //  SetFAttr( cTargetDir, 0 )
            //  FERASE( cTargetDir )
         ENDIF
      ENDIF
   NEXT

   nFreeSpace := hb_DiskSpace( cDriveTarget + ":" )
   IF nFreeSpace < nFilesSum
      MsgInfo( "Insufficient disk space for copying!" + CRLF + ;
               LTRIM( STR( nFreeSpace / 1024 / 1000 / 1000 ) ) + " Mb" + CRLF + ;
               LTRIM( STR( nFilesSum / 1024 / 1000 / 1000 ) ) + " Mb" )
   ELSE
      // Prep4Copy( "COPY", lPaperbin, lAdjustTime, acFiles, acTarget, aToDo , nCountry )
      RunAsThread( "COPY", lPaperbin, lAdjustTime, acFiles, acTarget, aToDo, nCountry, 2 )
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Procedure Clean_Label()
*+
*+    Called from ( backup.prg )   2 - static procedure donow()
*+                ( shellop.prg )   2 - static procedure reset_attribut()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Clean_Label()

   BackDlg.Label_1.Value := ""
   BackDlg.Label_2.Value := ""
   BackDlg.Label_3.Value := ""
   BackDlg.Label_4.Value := ""
   BackDlg.Label_5.Value := ""
RETURN

*+--------------------------------------------------------------------
*+
*+    Function Recudirs()
*+
*+    Called from ( backup.prg )   1 - static procedure donow()
*+                                   1 - function recudirs()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Recudirs( cPath, cMask, cAttr )

LOCAL c_File
LOCAL n_Size
LOCAL c_Attr
LOCAL a_DIR
LOCAL n_LEN
LOCAL n_Count
LOCAL cTemp, aFiles, ii, iMax, a_File := {}

   a_DIR := DIRECTORY( cPath + "*.*", "DHS" )
   n_LEN := LEN( a_DIR )

   FOR n_Count := 1 TO n_LEN
      c_File := a_DIR[ n_Count, F_NAME ]
      c_Attr := a_DIR[ n_Count, F_ATTR ]
      n_Size := a_DIR[ n_Count, F_SIZE ]

      IF ( c_File = ".." .AND. LEN( c_File ) = 2 ) .OR. ;
           ( c_File = "." .AND. LEN( c_File ) = 1 )
         LOOP
      ENDIF

      IF "D" $ c_Attr
         RECUDIRS( cPath + c_File + "\", cMask, cAttr )
      ELSE
         IF lOnlyNew = .T.                                            // if lOnlyNew
            IF "A" $ c_Attr                                           // it must have "A"
            ELSE
               LOOP
            ENDIF
         ENDIF

         AADD( aFilesCopy, { cPath, c_File, c_Attr, n_Size } )
         nFilesSum += n_Size
      ENDIF
   NEXT

   BackDlg.Label_2.Value := STR( nFilesSum / 1000000 ) + " MB"

RETURN .T.

*+--------------------------------------------------------------------
*+
*+    Static Function CheckDupeOK()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CheckDupeOK( aFilesCopy, aData )

LOCAL c_Path := aData[ ID_PATH ]
LOCAL c_File := aData[ ID_NAME ]
LOCAL c_Attr := aData[ ID_ATTR ]
LOCAL lRet   := .T.

   IF lOnlyNew = .T.                                                  // if lOnlyNew
      IF "A" $ c_Attr                                                 // it must have "A"
      ELSE
         RETURN .F.                                                   // not used when lOnlyNew
      ENDIF
   ENDIF

   IF ASCAN( aFilesCopy, { | x | x[ ID_PATH ] = c_Path .AND. x[ ID_NAME ] = c_File } ) > 0
      lRet := .F.
   ELSE
      IF ( cFullSource + "\" ) $ c_Path                               // Start-Path must be inside
         lRet := .T.
      ELSE
         lRet := .F.
      ENDIF
   ENDIF

RETURN lRet

*+--------------------------------------------------------------------
*+
*+    Procedure DoEject()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+                ( shellop.prg )   1 - static procedure reset_attribut()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoEject()

LOCAL cDrive
LOCAL nDrive := GetProperty( "BackDlg", "Combo_Target", "VALUE" )

   cDrive := aDrives[ nDrive ] [ DRV_NAME ]

   Do_EjectForm( cDrive, .T. )
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function No_Backshlash()
*+
*+    Called from ( backup.prg )   1 - static procedure doinit()
*+                                   2 - static procedure getsourcefolder()
*+                                   1 - static procedure donow()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION No_Backshlash( cIn )

LOCAL cOut  := ""
LOCAL nPosi, nLen

   IF !EMPTY( ALLTRIM( cIn ) )
      cIn := ALLTRIM( cIn )
      nLen := LEN( cIn )

      IF SUBSTR( cIn, nLen, 1 ) = "\" .AND. nLen > 3
         cOut := SUBSTR( cIn, 1, nLen - 1 )
      ELSE
         cOut := cIn
      ENDIF
   ENDIF

RETURN cOut

*+--------------------------------------------------------------------
*+
*+    Function USB_Detect()
*+
*+--------------------------------------------------------------------
*+
FUNCTION USB_Detect()

LOCAL nHWnd      := EventHWND()
LOCAL nMsg       := EventMSG()
LOCAL nWParam    := EventWPARAM()
LOCAL nLParam    := EventLPARAM()
LOCAL nMask, cDevice := ""
LOCAL xRet
LOCAL lThreatRet := hb_mutexSubscribe( s_mtxReturn, 0.00000001, @xRet )

   DO CASE

      CASE lThreatRet .AND. hb_isArray( xRet )
         //return message from Wait4Action thread
         Msginfo( xRet[ 1 ], STR( xRet[ 2 ] ) )

      CASE nMsg == WM_DEVICECHANGE
         DO CASE
            CASE nWParam == DBT_DEVICEARRIVAL
               nMask := DeviceChangeInfo( nWParam, nLParam )
               IF !EMPTY( nMask ) .AND. nMask > 0
                  cDevice := GetMaskDrive( nMask )
               ENDIF
               //send job
               hb_mutexNotify( s_mtxUSB, { "INSERT", cDevice, nMask, nHWnd } )

            CASE nWParam == DBT_DEVICEREMOVECOMPLETE
               nMask := DeviceChangeInfo( nWParam, nLParam )
               IF !EMPTY( nMask ) .AND. nMask > 0
                  cDevice := GetMaskDrive( nMask )
               ENDIF
               //send job
               hb_mutexNotify( s_mtxUSB, { "REMOVE", cDevice, nMask, nHWnd } )
         END CASE
   END CASE
RETURN cDevice

*+--------------------------------------------------------------------
*+
*+    Static Function Wait4Action()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Wait4Action()

LOCAL xUSB
LOCAL cAction     := ""
LOCAL cDevice     := ""
LOCAL cInfo       := ""
LOCAL nInfo       := 0
LOCAL ParrentHWnd
LOCAL lExit       := .F.

   DO WHILE !lExit
      hb_mutexSubscribe( s_mtxUSB,, @xUSB )                           //wait for job with params
      IF xUSB == NIL
         lExit := .T.
      ENDIF
      IF hb_IsArray( xUSB )
         cAction := xUSB[ 1 ]
         cDevice := xUSB[ 2 ]
         nInfo := xUSB[ 3 ]
         ParrentHWnd := xUSB[ 4 ]

         FillCombo()
         DoComboImage( .T. )
      ENDIF
   ENDDO

RETURN nil

*+--------------------------------------------------------------------
*+
*+    Static Function GetMaskDrive()
*+
*+    Called from ( backup.prg )   2 - function usb_detect()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION GetMaskDrive( nMask )

LOCAL cBin := NToC( nMask, 2 )
LOCAL nBit := LEN( cBin ) - hb_At( '1', cBin )
RETURN CHR( nBit + 65 ) + ":"

//
//
//

*+ EOF: BACKUP.PRG
