*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\BACKUP\\CODEPAGE.PRG
*+
*+    Copyright(C) 1983-2021 by Auge & Ohr
*+
*+    Functions: Function Search4Codepage()
*+               Function GetKeyboardInfoArray()
*+               Function GetCodePageInfoArray()
*+
*+    Reformatted by Click! 2.05.38 on Aug-26-2021 at  2:13 am
*+
*+--------------------------------------------------------------------

#define KBI_LOCALE      1
#define KBI_LANGCODE    2
#define KBI_LCIDDEZI    4

#define CBI_LOCALE      1
#define CBI_ISO         2
#define CBI_LANGLONG    3

*+--------------------------------------------------------------------
*+
*+    Function Search4Codepage()
*+
*+    Called from ( backup.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Search4Codepage()

LOCAL nCountry      := HB_bitAND( GETKEYBOARDLAYOUT(), 0xFFFF )
LOCAL aKeyboardInfo := GetKeyboardInfoArray()
LOCAL aCodePageInfo := GetCodePageInfoArray()
LOCAL nPosi, cCountry, cLCID, cCodepage, cMsg, nStart := 1

   nPosi := ASCAN( aKeyboardInfo, { | e | e[ KBI_LCIDDEZI ] = nCountry } )
   IF nPosi > 0
      cCountry := TRIM( aKeyboardInfo[ nPosi ] [ KBI_LOCALE ] )
      cLCID := UPPER( aKeyboardInfo[ nPosi ] [ KBI_LANGCODE ] )

      IF !EMPTY( cLCID )
         DO WHILE nPosi > 0
            nPosi := ASCAN( aCodePageInfo, { | e | TRIM( e[ CBI_LOCALE ] ) $ cCountry .AND. cLCID $ e[ CBI_LANGLONG ] }, nStart )
            IF nPosi > 0
               cCodepage := TRIM( aCodePageInfo[ nPosi ] [ CBI_LANGLONG ] )
               IF LEN( cCodepage ) = 2
                  cCodepage += TRIM( aCodePageInfo[ nPosi ] [ CBI_ISO ] )
               ENDIF
               cMsg := TRIM( aCodePageInfo[ nPosi ] [ CBI_LOCALE ] ) + " : " + cCodepage
               nStart := nPosi + 1
            ENDIF
         ENDDO

         hb_cdpselect( cCodepage )
      ELSE
         MsgInfo( "no Info of Language code LCID string for " + cCountry + " found" )
      ENDIF
   ENDIF
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function GetKeyboardInfoArray()
*+
*+    Called from ( codepage.prg )   1 - function search4codepage()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetKeyboardInfoArray()

LOCAL aKeyb := {}
   // Locale                            Language code  LCID string decimal hex   Codepage

   AADD( aKeyb, { "Afrikaans                    ", "af", "af   ", 1078, " 436", 1252 } )
   AADD( aKeyb, { "Albanian                     ", "sq", "sq   ", 1052, " 41C", 1250 } )
   AADD( aKeyb, { "Amharic                      ", "am", "am   ", 1118, " 45E", } )
   AADD( aKeyb, { "Arabic - Algeria             ", "ar", "ar-dz", 5121, "1401", 1256 } )
   AADD( aKeyb, { "Arabic - Bahrain             ", "ar", "ar-bh", 15361, "3C01", 1256 } )
   AADD( aKeyb, { "Arabic - Egypt               ", "ar", "ar-eg", 3073, " C01", 1256 } )
   AADD( aKeyb, { "Arabic - Iraq                ", "ar", "ar-iq", 2049, " 801", 1256 } )
   AADD( aKeyb, { "Arabic - Jordan              ", "ar", "ar-jo", 11265, "2C01", 1256 } )
   AADD( aKeyb, { "Arabic - Kuwait              ", "ar", "ar-kw", 13313, "3401", 1256 } )
   AADD( aKeyb, { "Arabic - Lebanon             ", "ar", "ar-lb", 12289, "3001", 1256 } )
   AADD( aKeyb, { "Arabic - Libya               ", "ar", "ar-ly", 4097, "1001", 1256 } )
   AADD( aKeyb, { "Arabic - Morocco             ", "ar", "ar-ma", 6145, "1801", 1256 } )
   AADD( aKeyb, { "Arabic - Oman                ", "ar", "ar-om", 8193, "2001", 1256 } )
   AADD( aKeyb, { "Arabic - Qatar               ", "ar", "ar-qa", 16385, "4001", 1256 } )
   AADD( aKeyb, { "Arabic - Saudi Arabia        ", "ar", "ar-sa", 1025, " 401", 1256 } )
   AADD( aKeyb, { "Arabic - Syria               ", "ar", "ar-sy", 10241, "2801", 1256 } )
   AADD( aKeyb, { "Arabic - Tunisia             ", "ar", "ar-tn", 7169, "1C01", 1256 } )
   AADD( aKeyb, { "Arabic - United Arab Emirates", "ar", "ar-ae", 14337, "3801", 1256 } )
   AADD( aKeyb, { "Arabic - Yemen               ", "ar", "ar-ye", 9217, "2401", 1256 } )
   AADD( aKeyb, { "Armenian                     ", "hy", "hy   ", 1067, " 42B", } )
   AADD( aKeyb, { "Assamese                     ", "as", "as   ", 1101, " 44D", } )
   AADD( aKeyb, { "Azeri - Cyrillic             ", "az", "az-az", 2092, " 82C", 1251 } )
   AADD( aKeyb, { "Azeri - Latin                ", "az", "az-az", 1068, " 42C", 1254 } )
   AADD( aKeyb, { "Basque                       ", "eu", "eu   ", 1069, " 42D", 1252 } )
   AADD( aKeyb, { "Belarusian                   ", "be", "be   ", 1059, " 423", 1251 } )
   AADD( aKeyb, { "Bengali - Bangladesh         ", "bn", "bn   ", 2117, " 845", } )
   AADD( aKeyb, { "Bengali - India              ", "bn", "bn   ", 1093, " 445", } )
   AADD( aKeyb, { "Bosnian                      ", "bs", "bs   ", 5146, "141A", } )
   AADD( aKeyb, { "Bulgarian                    ", "bg", "bg   ", 1026, " 402", 1251 } )
   AADD( aKeyb, { "Burmese                      ", "my", "my   ", 1109, " 455", } )
   AADD( aKeyb, { "Catalan                      ", "ca", "ca   ", 1027, " 403", 1252 } )
   AADD( aKeyb, { "Chinese - China              ", "zh", "zh-cn", 2052, " 804", } )
   AADD( aKeyb, { "Chinese - Hong Kong SAR      ", "zh", "zh-hk", 3076, " C04", } )
   AADD( aKeyb, { "Chinese - Macau SAR          ", "zh", "zh-mo", 5124, "1404", } )
   AADD( aKeyb, { "Chinese - Singapore          ", "zh", "zh-sg", 4100, "1004", } )
   AADD( aKeyb, { "Chinese - Taiwan             ", "zh", "zh-tw", 1028, " 404", } )
   AADD( aKeyb, { "Croatian                     ", "hr", "hr   ", 1050, " 41A", 1250 } )
   AADD( aKeyb, { "Czech                        ", "cs", "cs   ", 1029, " 405", 1250 } )
   AADD( aKeyb, { "Danish                       ", "da", "da   ", 1030, " 406", 1252 } )
   AADD( aKeyb, { "Dutch - Belgium              ", "nl", "nl-be", 2067, " 813", 1252 } )
   AADD( aKeyb, { "Dutch - Netherlands          ", "nl", "nl-nl", 1043, " 413", 1252 } )
   AADD( aKeyb, { "Edo                          ", "  ", "     ", 1126, " 466", } )
   AADD( aKeyb, { "English - Australia          ", "en", "en-au", 3081, " C09", 1252 } )
   AADD( aKeyb, { "English - Belize             ", "en", "en-bz", 10249, "2809", 1252 } )
   AADD( aKeyb, { "English - Canada             ", "en", "en-ca", 4105, "1009", 1252 } )
   AADD( aKeyb, { "English - Caribbean          ", "en", "en-cb", 9225, "2409", 1252 } )
   AADD( aKeyb, { "English - Great Britain      ", "en", "en-gb", 2057, " 809", 1252 } )
   AADD( aKeyb, { "English - India              ", "en", "en-in", 16393, "4009", } )
   AADD( aKeyb, { "English - Ireland            ", "en", "en-ie", 6153, "1809", 1252 } )
   AADD( aKeyb, { "English - Jamaica            ", "en", "en-jm", 8201, "2009", 1252 } )
   AADD( aKeyb, { "English - New Zealand        ", "en", "en-nz", 5129, "1409", 1252 } )
   AADD( aKeyb, { "English - Philippines        ", "en", "en-ph", 13321, "3409", 1252 } )
   AADD( aKeyb, { "English - Southern Africa    ", "en", "en-za", 7177, "1C09", 1252 } )
   AADD( aKeyb, { "English - Trinidad           ", "en", "en-tt", 11273, "2C09", 1252 } )
   AADD( aKeyb, { "English - United States      ", "en", "en-us", 1033, " 409", 1252 } )
   AADD( aKeyb, { "English - Zimbabwe           ", "en", "     ", 12297, "3009", 1252 } )
   AADD( aKeyb, { "Estonian                     ", "et", "et   ", 1061, " 425", 1257 } )
   AADD( aKeyb, { "FYRO Macedonia               ", "mk", "mk   ", 1071, " 42F", 1251 } )
   AADD( aKeyb, { "Faroese                      ", "fo", "fo   ", 1080, " 438", 1252 } )
   AADD( aKeyb, { "Farsi - Persian              ", "fa", "fa   ", 1065, " 429", 1256 } )
   AADD( aKeyb, { "Filipino                     ", "  ", "     ", 1124, " 464", } )
   AADD( aKeyb, { "Finnish                      ", "fi", "fi   ", 1035, " 40B", 1252 } )
   AADD( aKeyb, { "French - Belgium             ", "fr", "fr-be", 2060, " 80C", 1252 } )
   AADD( aKeyb, { "French - Cameroon            ", "fr", "     ", 11276, "2C0C", } )
   AADD( aKeyb, { "French - Canada              ", "fr", "fr-ca", 3084, " C0C", 1252 } )
   AADD( aKeyb, { "French - Congo               ", "fr", "     ", 9228, "240C", } )
   AADD( aKeyb, { "French - Cote d'Ivoire       ", "fr", "     ", 12300, "300C", } )
   AADD( aKeyb, { "French - France              ", "fr", "fr-fr", 1036, " 40C", 1252 } )
   AADD( aKeyb, { "French - Luxembourg          ", "fr", "fr-lu", 5132, "140C", 1252 } )
   AADD( aKeyb, { "French - Mali                ", "fr", "     ", 13324, "340C", } )
   AADD( aKeyb, { "French - Monaco              ", "fr", "     ", 6156, "180C", 1252 } )
   AADD( aKeyb, { "French - Morocco             ", "fr", "     ", 14348, "380C", } )
   AADD( aKeyb, { "French - Senegal             ", "fr", "     ", 10252, "280C", } )
   AADD( aKeyb, { "French - Switzerland         ", "fr", "fr-ch", 4108, "100C", 1252 } )
   AADD( aKeyb, { "French - West Indies         ", "fr", "     ", 7180, "1C0C", } )
   AADD( aKeyb, { "Frisian - Netherlands        ", "  ", "     ", 1122, " 462", } )
   AADD( aKeyb, { "Gaelic - Ireland             ", "gd", "gd-ie", 2108, " 83C", } )
   AADD( aKeyb, { "Gaelic - Scotland            ", "gd", "gd   ", 1084, " 43C", } )
   AADD( aKeyb, { "Galician                     ", "gl", "     ", 1110, " 456", 1252 } )
   AADD( aKeyb, { "Georgian                     ", "ka", "     ", 1079, " 437", } )
   AADD( aKeyb, { "German - Austria             ", "de", "de-at", 3079, " C07", 1252 } )
   AADD( aKeyb, { "German - Germany             ", "de", "de-de", 1031, " 407", 1252 } )
   AADD( aKeyb, { "German - Liechtenstein       ", "de", "de-li", 5127, "1407", 1252 } )
   AADD( aKeyb, { "German - Luxembourg          ", "de", "de-lu", 4103, "1007", 1252 } )
   AADD( aKeyb, { "German - Switzerland         ", "de", "de-ch", 2055, " 807", 1252 } )
   AADD( aKeyb, { "Greek                        ", "el", "el   ", 1032, " 408", 1253 } )
   AADD( aKeyb, { "Guarani - Paraguay           ", "gn", "gn   ", 1140, " 474", } )
   AADD( aKeyb, { "Gujarati                     ", "gu", "gu   ", 1095, " 447", } )
   AADD( aKeyb, { "HID (Human Interface Device) ", "  ", "     ", 1279, " 4FF", } )
   AADD( aKeyb, { "Hebrew                       ", "he", "he   ", 1037, " 40D", 1255 } )
   AADD( aKeyb, { "Hindi                        ", "hi", "hi   ", 1081, " 439", } )
   AADD( aKeyb, { "Hungarian                    ", "hu", "hu   ", 1038, " 40E", 1250 } )
   AADD( aKeyb, { "Icelandic                    ", "is", "is   ", 1039, " 40F", 1252 } )
   AADD( aKeyb, { "Igbo - Nigeria               ", "  ", "     ", 1136, " 470", } )
   AADD( aKeyb, { "Indonesian                   ", "id", "id   ", 1057, " 421", 1252 } )
   AADD( aKeyb, { "Italian - Italy              ", "it", "it-it", 1040, " 410", 1252 } )
   AADD( aKeyb, { "Italian - Switzerland        ", "it", "it-ch", 2064, " 810", 1252 } )
   AADD( aKeyb, { "Japanese                     ", "ja", "ja   ", 1041, " 411", } )
   AADD( aKeyb, { "Kannada                      ", "kn", "kn   ", 1099, " 44B", } )
   AADD( aKeyb, { "Kashmiri                     ", "ks", "ks   ", 1120, " 460", } )
   AADD( aKeyb, { "Kazakh                       ", "kk", "kk   ", 1087, " 43F", 1251 } )
   AADD( aKeyb, { "Khmer                        ", "km", "km   ", 1107, " 453", } )
   AADD( aKeyb, { "Konkani                      ", "  ", "     ", 1111, " 457", } )
   AADD( aKeyb, { "Korean                       ", "ko", "ko   ", 1042, " 412", } )
   AADD( aKeyb, { "Kyrgyz - Cyrillic            ", "  ", "     ", 1088, " 440", 1251 } )
   AADD( aKeyb, { "Lao                          ", "lo", "lo   ", 1108, " 454", } )
   AADD( aKeyb, { "Latin                        ", "la", "la   ", 1142, " 476", } )
   AADD( aKeyb, { "Latvian                      ", "lv", "lv   ", 1062, " 426", 1257 } )
   AADD( aKeyb, { "Lithuanian                   ", "lt", "lt   ", 1063, " 427", 1257 } )
   AADD( aKeyb, { "Malay - Brunei               ", "ms", "ms-bn", 2110, " 83E", 1252 } )
   AADD( aKeyb, { "Malay - Malaysia             ", "ms", "ms-my", 1086, " 43E", 1252 } )
   AADD( aKeyb, { "Malayalam                    ", "ml", "ml   ", 1100, " 44C", } )
   AADD( aKeyb, { "Maltese                      ", "mt", "mt   ", 1082, " 43A", } )
   AADD( aKeyb, { "Manipuri                     ", "  ", "     ", 1112, " 458", } )
   AADD( aKeyb, { "Maori                        ", "mi", "mi   ", 1153, " 481", } )
   AADD( aKeyb, { "Marathi                      ", "mr", "mr   ", 1102, " 44E", } )
   AADD( aKeyb, { "Mongolian                    ", "mn", "mn   ", 2128, " 850", } )
   AADD( aKeyb, { "Mongolian                    ", "mn", "mn   ", 1104, " 450", 1251 } )
   AADD( aKeyb, { "Nepali                       ", "ne", "ne   ", 1121, " 461", } )
   AADD( aKeyb, { "Norwegian - Bokml            ", "nb", "no-no", 1044, " 414", 1252 } )
   AADD( aKeyb, { "Norwegian - Nynorsk          ", "nn", "no-no", 2068, " 814", 1252 } )
   AADD( aKeyb, { "Oriya                        ", "or", "or   ", 1096, " 448", } )
   AADD( aKeyb, { "Polish                       ", "pl", "pl   ", 1045, " 415", 1250 } )
   AADD( aKeyb, { "Portuguese - Brazil          ", "pt", "pt-br", 1046, " 416", 1252 } )
   AADD( aKeyb, { "Portuguese - Portugal        ", "pt", "pt-pt", 2070, " 816", 1252 } )
   AADD( aKeyb, { "Punjabi                      ", "pa", "pa   ", 1094, " 446", } )
   AADD( aKeyb, { "Raeto-Romance                ", "rm", "rm   ", 1047, " 417", } )
   AADD( aKeyb, { "Romanian - Moldova           ", "ro", "ro-mo", 2072, " 818", } )
   AADD( aKeyb, { "Romanian - Romania           ", "ro", "ro   ", 1048, " 418", 1250 } )
   AADD( aKeyb, { "Russian                      ", "ru", "ru   ", 1049, " 419", 1251 } )
   AADD( aKeyb, { "Russian - Moldova            ", "ru", "ru-mo", 2073, " 819", } )
   AADD( aKeyb, { "Sami Lappish                 ", "  ", "     ", 1083, " 43B", } )
   AADD( aKeyb, { "Sanskrit                     ", "sa", "sa   ", 1103, " 44F", } )
   AADD( aKeyb, { "Serbian - Cyrillic           ", "sr", "sr-sp", 3098, " C1A", 1251 } )
   AADD( aKeyb, { "Serbian - Latin              ", "sr", "sr-sp", 2074, " 81A", 1250 } )
   AADD( aKeyb, { "Sesotho (Sutu)               ", "  ", "     ", 1072, " 430", } )
   AADD( aKeyb, { "Setsuana                     ", "tn", "tn   ", 1074, " 432", } )
   AADD( aKeyb, { "Sindhi                       ", "sd", "sd   ", 1113, " 459", } )
   AADD( aKeyb, { "Slovak                       ", "sk", "sk   ", 1051, " 41B", 1250 } )
   AADD( aKeyb, { "Slovenian                    ", "sl", "sl   ", 1060, " 424", 1250 } )
   AADD( aKeyb, { "Somali                       ", "so", "so   ", 1143, " 477", } )
   AADD( aKeyb, { "Sorbian                      ", "sb", "sb   ", 1070, " 42E", } )
   AADD( aKeyb, { "Spanish - Argentina          ", "es", "es-ar", 11274, "2C0A", 1252 } )
   AADD( aKeyb, { "Spanish - Bolivia            ", "es", "es-bo", 16394, "400A", 1252 } )
   AADD( aKeyb, { "Spanish - Chile              ", "es", "es-cl", 13322, "340A", 1252 } )
   AADD( aKeyb, { "Spanish - Colombia           ", "es", "es-co", 9226, "240A", 1252 } )
   AADD( aKeyb, { "Spanish - Costa Rica         ", "es", "es-cr", 5130, "140A", 1252 } )
   AADD( aKeyb, { "Spanish - Dominican Republic ", "es", "es-do", 7178, "1C0A", 1252 } )
   AADD( aKeyb, { "Spanish - Ecuador            ", "es", "es-ec", 12298, "300A", 1252 } )
   AADD( aKeyb, { "Spanish - El Salvador        ", "es", "es-sv", 17418, "440A", 1252 } )
   AADD( aKeyb, { "Spanish - Guatemala          ", "es", "es-gt", 4106, "100A", 1252 } )
   AADD( aKeyb, { "Spanish - Honduras           ", "es", "es-hn", 18442, "480A", 1252 } )
   AADD( aKeyb, { "Spanish - Mexico             ", "es", "es-mx", 2058, " 80A", 1252 } )
   AADD( aKeyb, { "Spanish - Nicaragua          ", "es", "es-ni", 19466, "4C0A", 1252 } )
   AADD( aKeyb, { "Spanish - Panama             ", "es", "es-pa", 6154, "180A", 1252 } )
   AADD( aKeyb, { "Spanish - Paraguay           ", "es", "es-py", 15370, "3C0A", 1252 } )
   AADD( aKeyb, { "Spanish - Peru               ", "es", "es-pe", 10250, "280A", 1252 } )
   AADD( aKeyb, { "Spanish - Puerto Rico        ", "es", "es-pr", 20490, "500A", 1252 } )
   AADD( aKeyb, { "Spanish - Spain (Traditional)", "es", "es-es", 1034, " 40A", 1252 } )
   AADD( aKeyb, { "Spanish - Uruguay            ", "es", "es-uy", 14346, "380A", 1252 } )
   AADD( aKeyb, { "Spanish - Venezuela          ", "es", "es-ve", 8202, "200A", 1252 } )
   AADD( aKeyb, { "Swahili                      ", "sw", "sw   ", 1089, " 441", 1252 } )
   AADD( aKeyb, { "Swedish - Finland            ", "sv", "sv-fi", 2077, " 81D", 1252 } )
   AADD( aKeyb, { "Swedish - Sweden             ", "sv", "sv-se", 1053, " 41D", 1252 } )
   AADD( aKeyb, { "Syriac                       ", "  ", "     ", 1114, " 45A", } )
   AADD( aKeyb, { "Tajik                        ", "tg", "tg   ", 1064, " 428", } )
   AADD( aKeyb, { "Tamil                        ", "ta", "ta   ", 1097, " 449", } )
   AADD( aKeyb, { "Tatar                        ", "tt", "tt   ", 1092, " 444", 1251 } )
   AADD( aKeyb, { "Telugu                       ", "te", "te   ", 1098, " 44A", } )
   AADD( aKeyb, { "Thai                         ", "th", "th   ", 1054, " 41E", } )
   AADD( aKeyb, { "Tibetan                      ", "bo", "bo   ", 1105, " 451", } )
   AADD( aKeyb, { "Tsonga                       ", "ts", "ts   ", 1073, " 431", } )
   AADD( aKeyb, { "Turkish                      ", "tr", "tr   ", 1055, " 41F", 1254 } )
   AADD( aKeyb, { "Turkmen                      ", "tk", "tk   ", 1090, " 442", } )
   AADD( aKeyb, { "Ukrainian                    ", "uk", "uk   ", 1058, " 422", 1251 } )
   AADD( aKeyb, { "Unicode                      ", "  ", "UTF-8", 0, "    ", } )
   AADD( aKeyb, { "Urdu                         ", "ur", "ur   ", 1056, " 420", 1256 } )
   AADD( aKeyb, { "Uzbek - Cyrillic             ", "uz", "uz-uz", 2115, " 843", 1251 } )
   AADD( aKeyb, { "Uzbek - Latin                ", "uz", "uz-uz", 1091, " 443", 1254 } )
   AADD( aKeyb, { "Venda                        ", "  ", "     ", 1075, " 433", } )
   AADD( aKeyb, { "Vietnamese                   ", "vi", "vi   ", 1066, " 42A", 1258 } )
   AADD( aKeyb, { "Welsh                        ", "cy", "cy   ", 1106, " 452", } )
   AADD( aKeyb, { "Xhosa                        ", "xh", "xh   ", 1076, " 434", } )
   AADD( aKeyb, { "Yiddish                      ", "yi", "yi   ", 1085, " 43D", } )
   AADD( aKeyb, { "Zulu                         ", "zu", "zu   ", 1077, " 435", } )

RETURN aKeyb

*+--------------------------------------------------------------------
*+
*+    Function GetCodePageInfoArray()
*+
*+    Called from ( codepage.prg )   1 - function search4codepage()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetCodePageInfoArray()

   //  https://vivaclipper.wordpress.com/2014/01/16/hb_cdpselect/
LOCAL aCDP := {}

   AADD( aCDP, { "Bulgarian           ", "866         ", "BG866 " } )
   AADD( aCDP, { "Bulgarian           ", "ISO-8859-5  ", "BGISO " } )
   AADD( aCDP, { "Bulgarian           ", "MIK         ", "BGMIK " } )
   AADD( aCDP, { "Bulgarian           ", "Windows-1251", "BGWIN " } )
   AADD( aCDP, { "Croatian            ", "437         ", "HR437 " } )
   AADD( aCDP, { "Croatian            ", "852         ", "HR852 " } )
   AADD( aCDP, { "Croatian            ", "Windows-1250", "HR1250" } )
   AADD( aCDP, { "Czech               ", "852         ", "CS852 " } )
   AADD( aCDP, { "Czech               ", "ISO-8859-2  ", "CSISO " } )
   AADD( aCDP, { "Czech               ", "KAM         ", "CSKAM " } )
   AADD( aCDP, { "Czech               ", "Windoes-1250", "CSWIN " } )
   AADD( aCDP, { "English             ", "437         ", "EN    " } )
   AADD( aCDP, { "French              ", "850         ", "FR    " } )
   AADD( aCDP, { "German              ", "850         ", "DE    " } )
   AADD( aCDP, { "German              ", "ISO-8859-1  ", "DEWIN " } )
   AADD( aCDP, { "Greek               ", "737         ", "EL    " } )
   AADD( aCDP, { "Greek               ", "Windows-1253", "ELWIN " } )
   AADD( aCDP, { "Hungarian (ntxhu852)", "852         ", "HU852 " } )
   AADD( aCDP, { "Hungarian (sixhu852)", "852         ", "HU852S" } )
   AADD( aCDP, { "Hungarian (ntxhu852)", "ISO-8859-2  ", "HUISO " } )
   AADD( aCDP, { "Hungarian (sixhu852)", "ISO-8859-2  ", "HUISOS" } )
   AADD( aCDP, { "Hungarian (ntxhu852)", "Windows-1250", "HUWIN " } )
   AADD( aCDP, { "Hungarian (sixhu852)", "Windows-1250", "HUWINS" } )
   AADD( aCDP, { "Italian             ", "437         ", "IT437 " } )
   AADD( aCDP, { "Italian             ", "850         ", "IT850 " } )
   AADD( aCDP, { "Italian             ", "ISO-8859-1b ", "ITISB " } )
   AADD( aCDP, { "Italian             ", "ISO-8859-1  ", "ITISO " } )
   AADD( aCDP, { "Lithuanian          ", "Windows-1257", "LT    " } )
   AADD( aCDP, { "Polish              ", "852         ", "PL852 " } )
   AADD( aCDP, { "Polish              ", "ISO-8859-2  ", "PLISO " } )
   AADD( aCDP, { "Polish              ", "Mazowia     ", "PLMAZ " } )
   AADD( aCDP, { "Polish              ", "Windows-1250", "PLWIN " } )
   AADD( aCDP, { "Portuguese          ", "850         ", "PT850 " } )
   AADD( aCDP, { "Portuguese          ", "ISO-8859-1  ", "PTISO " } )
   AADD( aCDP, { "Russian             ", "866         ", "RU866 " } )
   AADD( aCDP, { "Russian             ", "KOI-8       ", "RUKOI8" } )
   AADD( aCDP, { "Russian             ", "Windows-1251", "RU1251" } )
   AADD( aCDP, { "Serbian             ", "Windows-1251", "SRWIN " } )
   AADD( aCDP, { "Slovak              ", "852         ", "SK852 " } )
   AADD( aCDP, { "Slovak              ", "ISO-8859-2  ", "SKISO " } )
   AADD( aCDP, { "Slovak              ", "Kamenicky   ", "SKKAM " } )
   AADD( aCDP, { "Slovak              ", "Windows-1250", "SKWIN " } )
   AADD( aCDP, { "Slovenian           ", "437         ", "SL437 " } )
   AADD( aCDP, { "Slovenian           ", "852         ", "SL852 " } )
   AADD( aCDP, { "Slovenian           ", "ISO-8859-2  ", "SLISO " } )
   AADD( aCDP, { "Slovenian           ", "Windows-1250", "SLWIN " } )
   AADD( aCDP, { "Spanish             ", "850         ", "ES    " } )
   AADD( aCDP, { "Spanish             ", "ISO-8859-1  ", "ESWIN " } )
   AADD( aCDP, { "Spanish Modern      ", "ISO-8859-1  ", "ESMWIN" } )
   AADD( aCDP, { "Swedish             ", "850         ", "SV850 " } )
   AADD( aCDP, { "Swedish (Clipper)   ", "437         ", "SVCLIP" } )
   AADD( aCDP, { "Swedish             ", "ISO-8859-1  ", "SVWIN " } )
   AADD( aCDP, { "Turkish             ", "857         ", "TR857 " } )
   AADD( aCDP, { "Turkish             ", "Windows-1254", "TRWIN " } )
   AADD( aCDP, { "Ukrainian           ", "866         ", "UA866 " } )
   AADD( aCDP, { "Ukrainian           ", "KOI-8U      ", "UAKOI8" } )
   AADD( aCDP, { "Ukrainian           ", "Windows-1251", "UA1251" } )

RETURN aCDP

*+ EOF: CODEPAGE.PRG
