*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\BACKUP\\SHELLOP.PRG
*+
*+    Copyright(C) 1983-2021 by Auge & Ohr
*+
*+    Functions: Procedure RunAsThread()
*+               Function Prep4Copy()
*+               Static Function ShellFiles()
*+               Static Procedure Error_Shell()
*+               Static Procedure Reset_Attribut()
*+               Function IsValidUnicode()
*+
*+    Reformatted by Click! 2.05.38 on Aug-26-2021 at  2:13 am
*+
*+--------------------------------------------------------------------

#include "hmg.ch"
#include "common.ch"
#include "Shell32.ch"
#include "hbwin.ch"
#include "hbthread.ch"
#include "Directry.ch"

MEMVAR _HMG_SYSDATA
MEMVAR aWatchThread

*+--------------------------------------------------------------------
*+
*+    Procedure RunAsThread()
*+
*+    Called from ( backup.prg )   1 - static function shthread()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE RunAsThread( cAction, lPaperbin, lAdjustTime, acFiles, acTarget, aToDo, nCountry, nAktion )

   IF aWatchThread[ 1 ] <> NIL
      hb_threadDetach( aWatchThread[ 1 ] )
      // hb_threadQuitRequest( aWatchThread[ 1 ] )                      // terminate thread
   ENDIF
   //  aWatchThread[ 1 ] :=  hb_threadStart( HB_THREAD_INHERIT_PUBLIC, @WatchDirLeft(), cNewPath )
   aWatchThread[ 1 ] := hb_threadStart( HB_BITOR( HB_THREAD_INHERIT_PUBLIC, HB_THREAD_MEMVARS_COPY ), @Prep4Copy(), cAction, lPaperbin, lAdjustTime, acFiles, acTarget, aToDo, nCountry, nAktion )
RETURN

*+--------------------------------------------------------------------
*+
*+    Function Prep4Copy()
*+
*+    Called from ( shellop.prg )   1 - procedure runasthread()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Prep4Copy( cAction, lPaperbin, lAdjustTime, acFiles, acTarget, aToDo, nCountry, nAktion )

LOCAL hWnd
LOCAL nFunc, fFlag
LOCAL iMax       := LEN( acFiles )
LOCAL nRet       := 0
LOCAL nStart
LOCAL lConfirm   := GetProperty( "BackDlg", "Check_Confim", "Value" )
LOCAL lAttrib    := GetProperty( "BackDlg", "Check_Attrib", "Value" )
LOCAL lRename    := GetProperty( "BackDlg", "Check_Rename", "Value" )
LOCAL lCHKsource := GetProperty( "BackDlg", "Check_SubDir", "Value" )

   // run in Thread so SET again
   SET EPOCH TO YEAR( DATE() ) - 50
   SET CENTURY ON

   // NO Codepage here
   IF nCountry = 1031
      SET LANGUAGE TO GERMAN
      SET DATE GERMAN
   ELSE
      SET LANGUAGE TO ENGLISH
      SET DATE AMERICAN
   ENDIF
   // use UTF8 here
   SET( _SET_CODEPAGE, "UTF8" )

   fFlag := FOF_SIMPLEPROGRESS

   DO CASE
      CASE cAction = "COPY"
         nFunc := FO_COPY
      CASE cAction = "MOVE"
         nFunc := FO_MOVE
      CASE cAction = "DELETE"
         nFunc := FO_DELETE
      CASE cAction = "RENAME"
         nFunc := FO_RENAME
   ENDCASE

   IF iMax > 1
      fFlag += FOF_MULTIDESTFILES
   ENDIF

   IF lPaperbin
      fFlag += FOF_ALLOWUNDO
   ENDIF

   IF lConfirm
   ELSE
      // fFlag += FOF_NOCONFIRMATION + FOF_RENAMEONCOLLISION + FOF_NOCONFIRMMKDIR
      fFlag += FOF_NOCONFIRMATION + FOF_NOCONFIRMMKDIR
   ENDIF

   // ===========================================================================
   // Function ShellFile( hParentWnd, aFiles, aTarget, nFunc, nFlag )
   //
   // Purpose:
   // Performs a copy, move, rename, or delete operation on a file system object.
   // Parameters:
   //   aFiles  is an Array of Source-Filenamestrings, or a single Filenamestring
   //   aTarget is an Array of Target-Filenamestrings, or a single Filenamestring
   //   nFunc   determines the action on the files:
   //           FO_MOVE, FO_COPY, FO_DELETE, FO_RENAME
   //   fFlag   Option Flag ( see the file SHELL32.CH )
   //
   // ===========================================================================

   nStart := SECONDS()
   nRet := ShellFiles( hWnd, acFiles, acTarget, nFunc, fFlag )

   DO EVENTS

   IF nRet = 0
      IF lAttrib
         Reset_Attribut( aToDo, lConfirm, nAktion )
      ELSE
         MsgInfo( "finish " + " " + LTRIM( STR( SECONDS() - nStart ) ) + " Sec." )
      ENDIF
   ELSE
      Error_Shell( nRet )
   ENDIF

   IF lAdjustTime = .T. .AND. cAction <> "DELETE"
      // AdjustTime(acFiles, acTarget,cSourceDir,cTargetDir)
      // DO EVENTS
   ENDIF

RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Static Function ShellFiles()
*+
*+    Called from ( shellop.prg )   1 - function prep4copy()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION ShellFiles( hWnd, acFiles, acTarget, nFunc, fFlag )

LOCAL cTemp
LOCAL cx, cIn
LOCAL nRet    := 0
LOCAL ccFiles, ccTarget

   // Parent Window
   IF EMPTY( hWnd )
      hWnd := GetActiveWindow()
   ENDIF

   // Operation Flag
   IF nFunc == NIL
      nFunc := FO_DELETE
   ENDIF

   // Options Flag
   IF fFlag == NIL
      fFlag := FOF_ALLOWUNDO
   ENDIF

   // SourceFiles, convert Array to String
   DEFAULT acFiles TO HB_UCHAR( 0 )
   IF VALTYPE( acFiles ) == "A"
      cTemp := ""
      cx := 1
      FOR cx := 1 TO LEN( acFiles )
         cIn := acFiles[ cx ]
         IF IsValidUnicode( cIn )
            cTemp += cIn + HB_UCHAR( 0 )
         ENDIF
      NEXT
      ccFiles := cTemp
   ENDIF
   ccFiles += HB_UCHAR( 0 )

   // TargetFiles, convert Array to String
   // use HB_UCHAR( 0 ) instead of CHR( 0 )
   DEFAULT acTarget TO HB_UCHAR( 0 )
   IF VALTYPE( acTarget ) == "A"
      cTemp := ""
      cx := 1
      FOR cx := 1 TO LEN( acTarget )
         cIn := acTarget[ cx ]
         IF IsValidUnicode( cIn )
            cTemp += cIn + HB_UCHAR( 0 )
         ENDIF
      NEXT
      ccTarget := cTemp
   ENDIF
   ccTarget += HB_UCHAR( 0 )

   // call SHFileOperation
   nRet := ShellFileOperation( hWnd, ccFiles, ccTarget, nFunc, fFlag )

RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Static Procedure Error_Shell()
*+
*+    Called from ( shellop.prg )   1 - function prep4copy()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Error_Shell( nErr )

   DO CASE
      CASE nErr = 2
         MsgInfo( "File not found ! try ANSI Version", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_SAMEFILE
         MsgInfo( "The source and destination files are the same file.", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_MANYSRC1DEST
         MsgInfo( "Multiple file paths were specified in the source buffer, but only one destination file path. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_DIFFDIR
         MsgInfo( "Rename operation was specified but the destination path is a different directory. Use the move operation instead. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_ROOTDIR
         MsgInfo( "The source is a root directory, which cannot be moved or renamed. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_OPCANCELLED
         MsgInfo( "The operation was cancelled by the user, or silently cancelled if the appropriate flags were supplied to SHFileOperation. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_DESTSUBTREE
         MsgInfo( "The destination is a subtree of the source. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_ACCESSDENIEDSRC
         MsgInfo( "Security settings denied access to the source. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_PATHTOODEEP
         MsgInfo( "The source or destination path exceeded or would exceed MAX_PATH. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_MANYDEST
         MsgInfo( "The operation involved multiple destination paths, which can fail in the case of a move operation. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_INVALIDFILES
         MsgInfo( "The path in the source or destination or both was invalid. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_DESTSAMETREE
         MsgInfo( "The source and destination have the same parent folder. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_FLDDESTISFILE
         MsgInfo( "The destination path is an existing file. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_FILEDESTISFLD
         MsgInfo( "The destination path is an existing folder. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_FILENAMETOOLONG
         MsgInfo( "The name of the file exceeds MAX_PATH. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_DEST_IS_CDROM
         MsgInfo( "The destination is a read-only CD-ROM, possibly unformatted. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_DEST_IS_DVD
         MsgInfo( "The destination is a read-only DVD, possibly unformatted. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_DEST_IS_CDRECORD
         MsgInfo( "The destination is a writable CD-ROM, possibly unformatted. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_FILE_TOO_LARGE
         MsgInfo( "The file involved in the operation is too large for the destination media or file system. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_SRC_IS_CDROM
         MsgInfo( "The source is a read-only CD-ROM, possibly unformatted. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_SRC_IS_DVD
         MsgInfo( "The source is a read-only DVD, possibly unformatted. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_SRC_IS_CDRECORD
         MsgInfo( "The source is a writable CD-ROM, possibly unformatted. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_ERROR_MAX
         MsgInfo( "MAX_PATH was exceeded during the operation. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_UNKNOWN_
         MsgInfo( "An unknown error occurred. This is typically due to an invalid path in the source or destination. This error does not occur on Windows Vista and later. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_ERRORONDEST_
         MsgInfo( "An unspecified error occurred on the destination. ", "Error ShellFileOperation" )
      CASE nErr = HB_WIN_DE_ROOTDIR_ERRORONDEST_
         MsgInfo( "Destination is a root directory and cannot be renamed. ", "Error ShellFileOperation" )
      OTHERWISE
         IF nErr = 1223
            MsgInfo( "break by User" )
         ELSE
            MsgInfo( "unknown Error " + VAR2CHAR( nErr ), "Error ShellFileOperation" )
         ENDIF
   ENDCASE
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Reset_Attribut()
*+
*+    Called from ( shellop.prg )   1 - function prep4copy()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Reset_Attribut( aToDo, lConfirm, nAktion )

LOCAL nLen, i, nAttr, jMax, j, nStart, cAttr, cTry
LOCAL cFile, lArchive, lRead, lHidden, lSystem, lChange, cDate, cTime, aDir
LOCAL nButton
LOCAL lEject  := GetProperty( "BackDlg", "Check_Eject", "Value" )

   nLen := LEN( aToDo )
   IF nLen > 0
      IF lConfirm = .T.
         IF MsgYesNo( "remove Attribut A from Files ?", "change Attribut" )
            nButton := "XBPMB_RET_OK"
         ELSE
            nButton := "XBPMB_RET_NO"
         ENDIF
      ELSE
         nButton := "XBPMB_RET_OK"
      ENDIF

      IF nButton = "XBPMB_RET_OK"
         Clean_Label()
         SetProperty( "BackDlg", "Label_1", "Value", "Start " + TIME() )

         nStart := SECONDS()
         FOR i = 1 TO nLen

            cFile := aToDo[ i ] [ 1 ]

            SetProperty( "BackDlg", "Label_4", "Value", "remove Attribut A " + ( STR( i ) ) + " of " + LTRIM( STR( nLen ) ) )
            SetProperty( "BackDlg", "Label_5", "Value", cFile )

            aDir := DIRECTORY( cFile, "DHS" )
            IF !EMPTY( aDir )
               cDate := DTOC( aDir[ 1 ] [ F_DATE ] )
               cTime := aDir[ 1 ] [ F_TIME ]

               lRead := "R" $ aDir[ 1 ] [ F_ATTR ]
               lHidden := "H" $ aDir[ 1 ] [ F_ATTR ]
               lSystem := "S" $ aDir[ 1 ] [ F_ATTR ]

               lChange := .F.                                         // do not change Date/Time
               lArchive := .F.                                        // reset 'A' Attribut

               SetAttribut( cFile, lArchive, lRead, lHidden, lSystem, lChange, cDate, cTime )
            ENDIF
         NEXT
         SetProperty( "BackDlg", "Label_2", "Value", "Stop " + " " + LTRIM( STR( SECONDS() - nStart ) ) + " Sec." )
      ENDIF

      IF lEject = .T. .AND. nAktion = 2
         Clean_Label()
         DoEject()
         DoMethod( "BackDlg", "Release" )
      ENDIF

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Function IsValidUnicode()
*+
*+    Called from ( shellop.prg )   2 - static function shellfiles()
*+
*+--------------------------------------------------------------------
*+
FUNCTION IsValidUnicode( cIn )

LOCAL lRet := .T.

   DO CASE
      CASE HMG_ANSI_TO_UNICODE( "松涛館.png" ) $ cIn
         lRet := .F.
      CASE "img.png" $ cIn
         lRet := .F.
   ENDCASE
RETURN lRet

*+ EOF: SHELLOP.PRG
